/**
* Main script file
* @package News Show Pro GK4
* @Copyright (C) 2009-2012 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: GK4 1.4 $
**/
jQuery(window).on("load", function(){
	jQuery('.nspMain').each(function(i, module){
		module = jQuery(module);
		if(!module.hasClass('activated')) {
			module.addClass('activated');
			var $G = $Gavick[module.attr('id')];
			var arts_actual = 0;
			var list_actual = 0;
			var arts_block_width = 0;
			var links_block_width = 0;
			var arts = module.find('.nspArt');
			var links = (module.find('.nspLinkScroll1')) ? module.find('.nspLinkScroll1').find('li') : [];
			var nspArtWidth = (module.find('.nspArt')) ? arts.eq(0).css('width') : null;
			var arts_per_page = $G['news_column'] * $G['news_rows'];
			var pages_amount = Math.ceil(arts.length / arts_per_page);
			var links_pages_amount = Math.ceil(Math.ceil(links.length / $G['links_amount']) / $G['links_columns_amount']);
			var hover_anim = module.hasClass('hover');
			var animation = true;
			// var art_scroller;
			// var link_scroller;
			var direction = module.attr('data-direction') == 'rtl' ? 'margin-right' : 'margin-left';

			var modInterface = {
				top: module.find('.nspTopInterface'),
				bottom: module.find('.nspBotInterface')
			};
			// arts
			if(arts.length > 0){
				arts_block_width = 100;
			}

			// links
			if(links.length > 0){
				links_block_width = 100;
			}

			function art_scroller($start) {
				var option = {};
				option[direction]=($start)+'%';
				module.find('.nspArtScroll2').animate(option, $G['animation_speed'], $G['animation_function']);
			}

			function link_scroller($start) {
				var option = {};
				option[direction]=($start)+'%';
				module.find('.nspLinkScroll2').animate(option, $G['animation_speed'], $G['animation_function']);
			}

			// top interface
			nsp_art_list(0, module, modInterface.top, pages_amount);
			nsp_art_list(0, module, modInterface.bottom, links_pages_amount);
			if(modInterface.top.length && modInterface.top.find('.nspPagination').length){
				modInterface.top.find('.nspPagination').find('li').each(function(i,item){
					item = jQuery(item);
					item.on(hover_anim ? 'mouseenter' : 'click', function(){
						art_scroller(-1 * i * arts_block_width);
						arts_actual = i;

						nsp_art_list(i, module, modInterface.top, pages_amount);
						animation = false;
						(function(){animation = true;}).delay($G['animation_interval'] * 0.8);
					});
				});
			}
			if(modInterface.top.length && modInterface.top.find('.nspPrev').length){
				modInterface.top.find('.nspPrev').on("click", function(){
					if(arts_actual == 0) arts_actual = pages_amount - 1;
					else arts_actual--;
					art_scroller(-1 * arts_actual * arts_block_width);

					nsp_art_list(arts_actual, module, modInterface.top, pages_amount);
					animation = false;
					(function(){animation = true;}).delay($G['animation_interval'] * 0.8);
				});
				modInterface.top.find('.nspNext').on("click", function(){
					if(arts_actual == pages_amount - 1) arts_actual = 0;
					else arts_actual++;
					art_scroller(-1 * arts_actual * arts_block_width);
					nsp_art_list(arts_actual, module, modInterface.top, pages_amount);
					animation = false;
					(function(){animation = true;}).delay($G['animation_interval'] * 0.8);
				});
			}
			// bottom interface
			if(modInterface.bottom.length && modInterface.bottom.find('.nspPagination').length){
				modInterface.bottom.find('.nspPagination').find('li').each(function(i, item){
					item = jQuery(item);
					item.on(hover_anim ? 'mouseenter' : 'click', function(){
						link_scroller(-1 * i * links_block_width);
						list_actual = i;

						nsp_art_list(i, module, modInterface.bottom, links_pages_amount);
					});
				});
			}
			if(modInterface.bottom.length && modInterface.bottom.find('.nspPrev').length){
				modInterface.bottom.find('.nspPrev').on("click", function(){
					if(list_actual == 0) list_actual = links_pages_amount - 1;
					else list_actual--;

					link_scroller(-1 * list_actual * links_block_width);

					nsp_art_list(list_actual, module, modInterface.bottom, links_pages_amount);
				});

				modInterface.bottom.find('.nspNext').on("click", function(){
					if(list_actual == links_pages_amount - 1) list_actual = 0;
					else list_actual++;
					link_scroller(-1 * list_actual * links_block_width);

					nsp_art_list(list_actual, module, modInterface.bottom, links_pages_amount);
				});
			}
			if(module.hasClass('autoanim')){
				(function(){
					if(modInterface.top && modInterface.top.find('.nspNext')){
						if(animation) modInterface.top.find('.nspNext').fireEvent("click");
					}else{
						if(arts_actual == pages_amount - 1) arts_actual = 0;
						else arts_actual++;

						art_scroller(-1 * arts_actual * arts_block_width);

						nsp_art_list(arts_actual, module, modInterface.top, pages_amount);
					}
				}).periodical($G['animation_interval']);
			}
		}
	});
	function nsp_art_list(i, module, position, num){
		if(position && position.find('.nspPagination').length){
			var pagination = position.find('.nspPagination');
			pagination.find('li').attr('class', '');
			pagination.find('li').eq(i).attr('class', 'active');
		}
		if(position && position.find('.nspCounter').length){
			position.find('.nspCounter').find('span').text((i+1) + ' / ' + num);
		}
	}
});